OpenTTD

- Main Page
- Related Pages
- Modules
- Namespaces
- Data Structures
- Files

- Data Structures
- Class Hierarchy
- Data Fields

Public Member Functions
NWidgetViewport Class Reference
Hierarchical widgets

Nested widget to display a viewport in a window. More...

`#include <widget_type.h>`

Inheritance diagram for NWidgetViewport:

## Public Member Functions
| NWidgetViewport (int index)
void | SetupSmallestSize (Window *w, bool init_array)
| Compute smallest size needed by the widget.
void | Draw (const Window *w)
| Draw the widgets of the tree.
void | InitializeViewport (Window *w, uint32 follow_flags, ZoomLevel zoom)
| Initialize the viewport of the window.
void | UpdateViewportCoordinates (Window *w)
| Update the position and size of the viewport (after eg a resize).
Public Member Functions inherited from NWidgetCore
| NWidgetCore (WidgetType tp, Colours colour, uint fill_x, uint fill_y, uint32 widget_data, StringID tool_tip)
| Initialization of a 'real' widget.
void | SetIndex (int index)
| Set index of the nested widget in the widget array.
void | SetDataTip (uint32 widget_data, StringID tool_tip)
| Set data and tool tip of the nested widget.
void | SetLowered (bool lowered)
| Lower or raise the widget.
bool | IsLowered () const
| Return whether the widget is lowered.
void | SetDisabled (bool disabled)
| Disable (grey-out) or enable the widget.
bool | IsDisabled () const
| Return whether the widget is disabled.
void | FillNestedArray (NWidgetBase **array, uint length)
NWidgetCore * | GetWidgetFromPos (int x, int y)
| Retrieve a widget by its position.
bool | IsHighlighted () const
| Return whether the widget is highlighted.
TextColour | GetHighlightColour () const
| Return the colour of the highlight.
void | SetHighlighted (TextColour highlight_colour)
| Highlight the widget or not.
Public Member Functions inherited from NWidgetResizeBase
| NWidgetResizeBase (WidgetType tp, uint fill_x, uint fill_y)
| Constructor for resizable nested widgets.
void | SetMinimalSize (uint min_x, uint min_y)
| Set minimal size of the widget.
void | SetMinimalTextLines (uint8 min_lines, uint8 spacing, FontSize size)
| Set minimal text lines for the widget.
void | SetFill (uint fill_x, uint fill_y)
| Set the filling of the widget from initial size.
void | SetResize (uint resize_x, uint resize_y)
| Set resize step of the widget.
void | AssignSizePosition (SizingType sizing, uint x, uint y, uint given_width, uint given_height, bool rtl)
| Assign size and position to the widget.
Public Member Functions inherited from NWidgetBase
| NWidgetBase (WidgetType tp)
| Base class constructor.
virtual NWidgetBase * | GetWidgetOfType (WidgetType tp)
| Retrieve a widget by its type.
void | SetPadding (uint8 top, uint8 right, uint8 bottom, uint8 left)
| Set additional space (padding) around the widget.
uint | GetHorizontalStepSize (SizingType sizing) const
| Get the horizontal sizing step.
uint | GetVerticalStepSize (SizingType sizing) const
| Get the vertical sizing step.
virtual void | SetDirty (const Window *w) const
| Mark the widget as 'dirty' (in need of repaint).
Public Member Functions inherited from ZeroedMemoryAllocator
void * | operator new (size_t size)
| Memory allocator for a single class instance.
void * | operator new[] (size_t size)
| Memory allocator for an array of class instances.
void | operator delete (void *ptr)
| Memory release for a single class instance.
void | operator delete[] (void *ptr)
| Memory release for an array of class instances.

## Additional Inherited Members
Data Fields inherited from NWidgetCore
NWidgetDisplay | disp_flags
| Flags that affect display and interaction with the widget.
Colours | colour
| Colour of this widget.
int | index
| Index of the nested widget in the widget array of the window (`-1` means 'not used').
uint32 | widget_data
| Data of the widget.
StringID | tool_tip
| Tooltip of the widget.
int | scrollbar_index
| Index of an attached scrollbar.
TextColour | highlight_colour
| Colour of highlight.
Protected Member Functions inherited from NWidgetBase
void | StoreSizePosition (SizingType sizing, uint x, uint y, uint given_width, uint given_height)
| Store size and position.

## Detailed Description

Nested widget to display a viewport in a window.

After initializing the nested widget tree, call InitializeViewport(). After changing the window size, call UpdateViewportCoordinates() eg from Window::OnResize(). If the #display_flags field contains the ND_NO_TRANSPARENCY bit, the viewport will disable transparency. Shading to grey-scale is controlled with the ND_SHADE_GREY bit (used for B&W news papers), the ND_SHADE_DIMMED gives dimmed colours (for colour news papers).

Todo:
  Class derives from NWidgetCore, but does not use colour, widget_data, or tool_tip.

Definition at line 575 of file widget_type.h.

## Member Function Documentation

void NWidgetViewport::Draw | ( | const Window * | w | ) |
| virtual

Draw the widgets of the tree.

The function calls Window::DrawWidget for each widget with a non-negative index, after the widget itself is painted.

Parameters

  w | Window that owns the tree.

Implements NWidgetBase.

Definition at line 1903 of file widget.cpp.

References _transparency_opt, NWidgetBase::current_x, NWidgetBase::current_y, NWidgetCore::disp_flags, Window::DrawViewport(), FILLRECT_RECOLOUR, GfxFillRect(), ND_NO_TRANSPARENCY, ND_SHADE_DIMMED, ND_SHADE_GREY, PALETTE_NEWSPAPER, PALETTE_TO_TRANSPARENT, NWidgetBase::pos_x, NWidgetBase::pos_y, TO_LOADING, and TO_SIGNS.

void NWidgetViewport::InitializeViewport | ( | Window * | w,
|  | uint32 | follow_flags,
|  | ZoomLevel | zoom
| ) |  |

Initialize the viewport of the window.

Parameters

  w | Window owning the viewport.
  follow_flags | Type of viewport, see InitializeWindowViewport().
  zoom | Zoom level.

Definition at line 1927 of file widget.cpp.

References NWidgetBase::current_x, NWidgetBase::current_y, InitializeWindowViewport(), NWidgetBase::pos_x, and NWidgetBase::pos_y.

Referenced by WaypointWindow::WaypointWindow().

void NWidgetViewport::SetupSmallestSize | ( | Window * | w,
|  | bool | init_array
| ) |  |
| virtual

Compute smallest size needed by the widget.

The smallest size of a widget is the smallest size that a widget needs to display itself properly. In addition, filling and resizing of the widget are computed. The function calls Window::UpdateWidgetSize for each leaf widget and background widget without child with a non-negative index.

Parameters

  w | Window owning the widget.
  init_array | Initialize the `w->nested_array`.

Note
  After the computation, the results can be queried by accessing the smallest_x and smallest_y data members of the widget.

Implements NWidgetBase.

Definition at line 1893 of file widget.cpp.

References NWidgetCore::index, NWidgetResizeBase::min_x, NWidgetResizeBase::min_y, Window::nested_array, Window::nested_array_size, NWidgetBase::smallest_x, and NWidgetBase::smallest_y.

void NWidgetViewport::UpdateViewportCoordinates | ( | Window * | w | ) |

Update the position and size of the viewport (after eg a resize).

Parameters

  w | Window owning the viewport.

Definition at line 1936 of file widget.cpp.

References NWidgetBase::current_x, NWidgetBase::current_y, ViewPort::height, ViewPort::left, Window::left, NWidgetBase::pos_x, NWidgetBase::pos_y, ScaleByZoom(), ViewPort::top, Window::top, Window::viewport, ViewPort::virtual_height, ViewPort::virtual_width, ViewPort::width, and ViewPort::zoom.

Referenced by ExtraViewportWindow::OnResize(), WaypointWindow::OnResize(), MainWindow::OnResize(), TownViewWindow::OnResize(), IndustryViewWindow::OnResize(), and VehicleViewWindow::OnResize().

The documentation for this class was generated from the following files:

- src/widget_type.h
- src/widget.cpp